/* Homework 2 Problem 2
 *
 * Computes A*B + C/D, where
 * A, B, C and D are defined below.
 *
 * Note:
 * B and D are constants, so they can be used
 * with "immediate" instructions like "muli"
 * and "movi". (Note: movi is used with D
 * because there is no divi instruction.)
 *
 * A and C are labels that point to variables stored
 * in memory, so you must use "ldw" to get their value.
 */

.equ	B, 5
.equ	D, 6

.global	_start

.text
_start:		movia	r10, A
		ldw	r2, 0(r10)		/* read A */
		muli	r11, r2, B		/* compute A*B */

		movia	r10, C
		ldw	r2, 0(r10)		/* read C */
		movi	r3, D
		div	r12, r2, r3		/* compute C/D */

		add	r11, r11, r12	/* add A*B and C/D */

STOP:		br	STOP

.data
A:
.word 7
C:
.word 24

.end
