/* Homework 2 Problem 6
 *
 * Decompress the values in the data section.
 * The COMPRESSED section contains pairs of words, COUNT and VALUE.
 * The DECOMPRESSED section should have COUNT copies of VALUE.
 * This repeats with each pair until a COUNT of 0 is discovered.
 */

.global	_start

.text
_start:	movia	r2, COMPRESSED
		movia r3, DECOMPRESSED

newpair:	ldw	r10, 0(r2)	/* COUNT */
		beq	r10, r0, STOP

/* write the word VALUE to DECOMPRESSED exactly COUNT times */
		ldw	r11, 4(r2)	/* VALUE */
nextword:	stw	r11, 0(r3)
		addi	r3, r3, 4
		subi	r10, r10, 1
		bne	r10, r0, nextword

/* advance to the next COUNT,VALUE pair in COMPRESSED stream */
		addi	r2, r2, 8
		br	newpair

STOP:		br	STOP


.data

COMPRESSED:
.word 3, 0xEECE, 2, 0x0259, 4, 0xF00D, 5, 0xCAFE, 0

DECOMPRESSED:
.skip 4*(3+2+4+5)

.end
